Skip to main content
`Ctrl`+`K`

# KSPComputeExtremeSingularValues

Computes the extreme singular values for the preconditioned operator. Called after or during `KSPSolve()`.

## Synopsis

    #include "petscksp.h"
    #include "petscmat.h"
    PetscErrorCode KSPComputeExtremeSingularValues(KSP ksp, PetscReal *emax, PetscReal *emin)

Not Collective

## Input Parameter

- ksp - iterative solver obtained from `KSPCreate()`

## Output Parameters

- emax - maximum estimated singular value

- emin - minimum estimated singular value

## Options Database Key

- -ksp_view_singularvalues - compute extreme singular values and print when `KSPSolve()` completes.

## Notes

One must call `KSPSetComputeSingularValues()` before calling `KSPSetUp()` (or use the option `-ksp_view_singularvalues`) in order for this routine to work correctly.

Many users may just want to use the monitoring routine `KSPMonitorSingularValue()` (which can be set with option `-ksp_monitor_singular_value`) to print the extreme singular values at each iteration of the linear solve.

Estimates of the smallest singular value may be very inaccurate, especially if the Krylov method has not converged. The largest singular value is usually accurate to within a few percent if the method has converged, but is still not intended for eigenanalysis. Consider the excellent package SLEPc if accurate values are required.

Disable restarts if using `KSPGMRES`, otherwise this estimate will only be using those iterations after the last restart. See `KSPGMRESSetRestart()` for more details.

## See Also

KSP: Linear System Solvers, `KSPSetComputeSingularValues()`, `KSPMonitorSingularValue()`, `KSPComputeEigenvalues()`, `KSP`, `KSPComputeRitz()`

## Level

advanced

## Location

src/ksp/ksp/interface/itfunc.c

## Examples

src/ksp/ksp/tutorials/ex56.c
src/ksp/ksp/tutorials/ex59.c

## Implementations

KSPComputeExtremeSingularValues_CG() in src/ksp/ksp/impls/cg/cgeig.c
KSPComputeExtremeSingularValues_FETIDP() in src/ksp/ksp/impls/fetidp/fetidp.c
KSPComputeExtremeSingularValues_GMRES() in src/ksp/ksp/impls/gmres/gmreig.c
KSPComputeExtremeSingularValues_MINRES() in src/ksp/ksp/impls/minres/minres.c

Index of all KSP routines
Table of Contents for all manual pages
Index of all manual pages